100 REMark character code translator for PC text files
110 REMark where the PC characters exist in the QL character set,
120 REMark this program translates what it can
130 REMark by Dilwyn Jones 1995
140 REMark needs Toolkit 2
150 REMark $$asmb=win1_bootup_qlib_ext,0,12
160 REMark $$asmb=flp1_edline_code,0,10
170 REMark $$asmb=flp1_trpc_cfg,0,12
180 DEF_INTEGER loop,c,cde
190 sd$ = C_STRG$(1) : REMark source drive
200 dd$ = C_STRG$(2) : REMark destination drive
210 :
220 IF Q_MYJOB <> 0 : OPEN #0,'con' : OPEN #1,'scr'
230 :
240 WINDOW 448,16,32,12 : PAPER 16 : INK 7 : BORDER 1,255 : CLS
250 WINDOW #0,448,100,32,27 : PAPER #0,0 : INK #0,7 : BORDER #0,1,255
260 CLS #0 : CURSOR 18,2
270 PRINT 'CONVERT PC TEXT FILE TO QL CHARACTER SET v';C_VERS$
280 CURSOR 354,2 : PRINT'LINES:';
290 :
300 REPeat program
310   CURSOR 390,2 :  CLS 4
320   PRINT #0,'Source filename:';
330   source$ = EDLINE$(#0,41,sd$)
340   IF source$ = '' THEN EXIT program
350   sd$ = EXTRACT_DRIVE$(sd$,source$)
360   dest$ = dd$&fnm$
370   PRINT #0,'Destination filename:';
380   dest$ = EDLINE$(#0,41,dest$)
390   IF dest$ = '' THEN NEXT program
400   dd$ = EXTRACT_DRIVE$(dd$,dest$)
410   fl = FLEN(\source$)
420   IF fl < 0 THEN
430     BEEP 5000,50: PRINT #0,'Oops, error ';fl : PAUSE 50 : NEXT program
440   END IF
450   ch = FOP_NEW(dest$)
460   IF ch < 0 THEN
470     BEEP 5000,50: PRINT #0,'Oops, error ';ch : PAUSE 50 : NEXT program
480   END IF
490   REMark reserve enough memory for source file to be loaded
500   base = ALCHP(fl)
510   IF base < 0 THEN
520     BEEP 5000,50: PRINT #0,'Oops, error ';base : PAUSE 50 : NEXT program
530   END IF
540   Q_ERR_ON 'lbytes' : LBYTES source$,base : fer = Q_ERR
550   Q_ERR_OFF 'lbytes'
560   IF fer < 0 THEN
570     BEEP 5000,50
580     PRINT #0,'Failed to load ';source$;' (Error ';fer;')'
590     RECHP base
600   END IF
610   tr = 0 : REMark number of translations done
620   cr = 0 : REMark number of CRs dropped
630   lf = 0 : REMark line count
640   PRINT #0,'Converting...'
650   Q_CURSON #0
660   FOR a = base+0 TO base+fl-1
670     k$ = INKEY$
680     IF k$ = CHR$(27) THEN
690       CLOSE #ch : RECHP base : DELETE dest$
700       PRINT #0,'<ESC>' : EXIT a
710     END IF
720     cde = PEEK(a)
730     SELect ON cde
740       =10  : c = cde : lf = lf + 1 : CURSOR 390,2 : PRINT lf;
750       =13  : cr = cr + 1 : NEXT a : EXIT a
760       =96  : c = 159 : tr = tr + 1
770       =128 : c = 166 : tr = tr + 1
780       =129 : c = 135 : tr = tr + 1
790       =130 : c = 131 : tr = tr + 1
800       =131 : c = 142 : tr = tr + 1
810       =132 : c = 128 : tr = tr + 1
820       =133 : c = 141 : tr = tr + 1
830       =134 : c = 130 : tr = tr + 1
840       =135 : c = 134 : tr = tr + 1
850       =136 : c = 145 : tr = tr + 1
860       =137 : c = 143 : tr = tr + 1
870       =138 : c = 144 : tr = tr + 1
880       =139 : c = 146 : tr = tr + 1
890       =140 : c = 149 : tr = tr + 1
900       =141 : c = 148 : tr = tr + 1
910       =142 : c = 160 : tr = tr + 1
920       =143 : c = 162 : tr = tr + 1
930       =144 : c = 163 : tr = tr + 1
940       =145 : c = 138 : tr = tr + 1
950       =146 : c = 170 : tr = tr + 1
960       =147 : c = 152 : tr = tr + 1
970       =148 : c = 132 : tr = tr + 1
980       =149 : c = 151 : tr = tr + 1
990       =150 : c = 155 : tr = tr + 1
1000       =151 : c = 154 : tr = tr + 1
1010       =152 : c = 121 : tr = tr + 1
1020       =153 : c = 164 : tr = tr + 1
1030       =154 : c = 167 : tr = tr + 1
1040       =155 : c = 157 : tr = tr + 1
1050       =156 : c = 96  : tr = tr + 1
1060       =157 : c = 158 : tr = tr + 1
1070       =159 : c = 102 : tr = tr + 1
1080       =160 : c = 140 : tr = tr + 1
1090       =161 : c = 147 : tr = tr + 1
1100       =162 : c = 150 : tr = tr + 1
1110       =163 : c = 153 : tr = tr + 1
1120       =164 : c = 137 : tr = tr + 1
1130       =165 : c = 169 : tr = tr + 1
1140       =166 : c = 97  : tr = tr + 1
1150       =167 : c = 111 : tr = tr + 1
1160       =168 : c = 180 : tr = tr + 1
1170       =173 : c = 179 : tr = tr + 1
1180       =174 : c = 184 : tr = tr + 1
1190       =175 : c = 185 : tr = tr + 1
1200       =176 TO 178 : c = 31 : tr = tr + 1 : REMark chequerboard
1210       =179 : c = 124 : tr = tr + 1
1220       =196 : c = 45  : tr = tr + 1
1230       =224 : c = 172 : tr = tr + 1
1240       =225 : c = 156 : tr = tr + 1
1250       =227 : c = 177 : tr = tr + 1
1260       =230 : c = 176 : tr = tr + 1
1270       =232 : c = 178 : tr = tr + 1
1280       =233 : c = 174 : tr = tr + 1
1290       =235 : c = 173 : tr = tr + 1
1300       =237 : c = 178 : tr = tr + 1
1310       =246 : c = 187 : tr = tr + 1
1320       =248 TO 250 : c = 186 : tr = tr + 1
1330       =254 : c = 31 : tr = tr + 1
1340       =REMAINDER : c = cde
1350     END SELect
1360     PRINT #ch,CHR$(c);
1370   END FOR a
1380   Q_CURSOFF #0
1390   IF k$ = CHR$(27) : NEXT program
1400   PRINT #0,\'Translated ';lf;' lines of text.'
1410   PRINT #0,'Translates : ';tr;', Carriage returns stripped = ';cr
1420   CLOSE #ch
1430   PRINT #0,'Original file length : ';fl;', new file length = ';FLEN(\dest$)
1440   REMark close #ch
1450   RECHP base : REMark release the area of memory used
1460   PRINT #0,FILL$('-',74)
1470 END REPeat program
1480 PRINT #0,'PROGRAM FINISHED.' : PAUSE 25
1490 STOP
1500 :
1510 DEFine FuNction EXTRACT_DRIVE$(defd$,str$)
1520   LOCal a
1530   a = '_' INSTR str$
1540   SELect ON a
1550     =0 : fnm$ = str$ : RETurn defd$
1560     =REMAINDER
1570       IF a < LEN(str$) THEN fnm$=str$(a+1 TO LEN(str$)):ELSE fnm$ = '' : END IF
1580       RETurn str$(1 TO a)
1590   END SELect
1600 END DEFine EXTRACT_DRIVE$
